]> git.treefish.org Git - backmeupscotty.git/blob - backmeupscotty
Made ssh calls 255 aware.
[backmeupscotty.git] / backmeupscotty
1 #!/bin/bash
2
3 REMOTE_HOST=localhost
4 REMOTE_DIR=/tmp/backmeupscotty/test
5 ARCHIVE_KEEPNBACKUPS=30
6 ARCHIVE_KEEPNDAYS=30
7 BACKUP_RUNEVERYNTHDAY=1
8
9 function upperme {
10     echo $(basename $0) | tr '[:lower:]' '[:upper:]'
11 }
12
13 function scottyinfo {
14     echo $(upperme): $@ 
15 }
16
17 function scottyerror {
18     echo $(upperme): $@ >&2 
19 }
20
21 function ssh255 {
22     ssh $@
23     sshret=$?
24
25     if [ $sshret -eq 255 ]; then
26         scottyerror "SSH connection failed!"
27         exit 1
28     else
29         return $sshret
30     fi
31 }
32
33 function grepbackups {
34     ssh255 $REMOTE_HOST "ls $REMOTE_DIR" | grep -E '[0-9]+-[0-9]+'
35 }
36
37 function isIncomplete {
38     if ( ssh255 $REMOTE_HOST '[ -d '$REMOTE_DIR/incomplete' ]' ); then
39         return 0
40     else
41         return 1
42     fi
43 }
44
45 function isNthDay {
46     if [ $(( ( $(date +%s) / (60*60*24) ) % $BACKUP_RUNEVERYNTHDAY )) -eq 0 ]; 
47     then
48         return 0
49     else
50         return 1
51     fi  
52 }
53
54 function latestTooOld {
55     for oldbackup in $(grepbackups); do
56         tstamp=$(echo $oldbackup | cut -d'-' -f1)
57         
58         if [ $(( $(date +%s) - $tstamp )) -lt \
59             $(( $BACKUP_RUNEVERYNTHDAY*24*60*60 )) ]
60         then
61             return 1
62         fi
63     done
64
65     return 0
66 }
67
68 function scottysync {
69     timestamp=$(date +%s)
70
71     scottyinfo Syncing $SYNC_SRC to $REMOTE_HOST:$REMOTE_DIR @$timestamp
72
73     if [ ! -d "$SYNC_SRC" ]; then
74         scottyerror Source dir $SYNC_SRC does not exist. Not syncing!
75         return 1
76     fi
77
78     if [ $(ls -A "$SYNC_SRC" | wc -l) -eq 0 ]; then
79         scottyerror Source dir $SYNC_SRC is empty. Not syncing!
80         return 1
81     fi
82
83     dir_current=$REMOTE_DIR/current
84     dir_incomplete=$REMOTE_DIR/incomplete
85     dir_timestamped=$REMOTE_DIR/$timestamp-$(date -d @$timestamp +%Y%m%d%H%M%S)
86
87     if [ -z $SYNC_EXC ]; then
88         rsync_exclude=""
89     else
90         rsync_exclude=$(eval echo --exclude={$SYNC_EXC} | tr -d {})
91     fi
92
93     if (ssh255 $REMOTE_HOST '[ ! -d '$REMOTE_DIR' ]'); then
94         scottyinfo Creating destination directory $REMOTE_HOST:$REMOTE_DIR
95         ssh255 $REMOTE_HOST "mkdir $REMOTE_DIR"
96     fi
97
98     if isIncomplete; then
99         scottyerror Continuing old incomplete backup
100     fi
101
102     scottyinfo Starting rsync
103     rsync -e ssh \
104         -v -aHAX --numeric-ids --delete --delete-excluded \
105         --link-dest=$dir_current \
106         $rsync_exclude \
107         $SYNC_SRC/ $REMOTE_HOST:$dir_incomplete/
108     
109     if [ $? -eq 0 ]; then
110         scottyinfo Timestamping completed backup and linking to current backup
111         ssh255 $REMOTE_HOST \
112             "mv $dir_incomplete $dir_timestamped && rm -f $dir_current && ln -s $(basename $dir_timestamped) $dir_current"
113     fi
114
115     while [ $(grepbackups | wc -l) -gt $ARCHIVE_KEEPNBACKUPS ]; do
116         oldestbackup=$(grepbackups | head -1)
117         oldestbackuptstamp=$(echo $oldestbackup | cut -d'-' -f1)
118
119         if [ $oldestbackuptstamp -lt $(( $(date +%s) - $ARCHIVE_KEEPNDAYS*60*60*24 )) ]; then
120             scottyinfo Removing old backup $oldestbackup
121             ssh255 $REMOTE_HOST rm -r "$REMOTE_DIR/$oldestbackup"
122         else
123             break
124         fi
125     done
126 }
127
128 function deleteLock {
129     if ! rmdir /tmp/$(basename $0).lock; then
130         scottyerror "Could not delete lockfile /tmp/$(basename $0).lock!"
131     fi
132 }
133
134 function prepare {
135     scottyinfo "Preparing for sync"
136 }
137
138 function cleanup_abort {
139     scottyerror "Caught exit signal! Cleaning up..."
140
141     cleanup ABORT
142
143     if [ $(jobs -p) ]; then
144         scottyerror TERMinating remaining child processes...
145         kill $(jobs -p)
146     fi
147
148     deleteLock
149
150     exit
151 }
152
153 function cleanup {
154     scottyinfo "No cleanup function was defined."
155 }
156
157 function prepare {
158     scottyinfo "No prepare function was defined."
159 }
160
161 function cleanup_normal {
162     cleanup
163     deleteLock
164 }
165
166 function printhelp {
167     cat <<EOF
168 Usage: $(basename $0) [OPTION]...
169
170 Recognized options:
171   -q   Only output errors
172   -n   Run only on nth day
173   -h   Print out this help
174 EOF
175 }
176
177 function backmeupscotty {
178     while getopts "qn:h" opt; do
179         case $opt in
180             q)
181                 exec > /dev/null
182                 ;;
183             n)
184                 BACKUP_RUNEVERYNTHDAY=$OPTARG
185                 ;;
186             h)
187                 printhelp
188                 exit 0
189                 ;;
190         esac
191     done
192     
193     ssh255 $REMOTE_HOST exit
194     
195     if isNthDay; then
196         scottyinfo "This is the nth day."
197     elif latestTooOld; then
198         scottyinfo "The latest backup is too old."
199     else
200         scottyinfo "No backup has to be done. Exiting."
201         exit 0
202     fi
203
204     scottyinfo "Performing backup."
205
206     trap cleanup_abort EXIT
207
208     prepare
209     scottysync
210
211     trap cleanup_normal EXIT
212
213     exit 0
214 }
215
216 if ! mkdir /tmp/$(basename $0).lock; then
217     scottyerror "Another instance of $(basename $0) is still running!"
218     exit 1
219 else
220     trap deleteLock EXIT
221 fi